# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
  
    url = "https://www.zimbra.com/product/addons/zimbra-connector-for-outlook-download/"
    print(f'URL used is: {url}')

    for arch in ['x86', 'x64']:

        print(f'Processing {arch} version')
        for bs_search in bs_find_all(url, 'a', 'rel', 'noopener', proxies=proxies):
            if f'_{arch}.msi' in bs_search.get('href', ''):
                download_url = bs_search['href']
                latest_bin = download_url.rsplit('/', 1)[-1]
                version = latest_bin.split('_')[1]
                break

        print(f'Latest {control.name} {arch} version is: {version}')
        print(f'Download URL for {arch} is: {download_url}')

        # Downloading latest binaries
        print(f'Downloading: {latest_bin}')
        latest_bin_split = latest_bin.split('_')
        latest_bin = f'{latest_bin_split[0]}_{latest_bin_split[2]}'
        wget(download_url, latest_bin, proxies=proxies)

        # Checking version from file
        version_from_file = get_version_from_binary(latest_bin).split('.')[-1]
        if Version(version_from_file, 4) == Version(version, 4):
            print(f'INFO: Binary file version ({version_from_file}) corresponds to online version ({version})')
        else:
            error(f'ERROR: Binary file version ({version_from_file}) do NOT corresponds to online version ({version})')

    # Downloading latest binaries
    print(f"Latest {app_name} version is: {version}")
    print(f"Download URL is: {download_url}")
    if not isfile(latest_bin):
        print(f"Downloading: {latest_bin}")
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print(f"Binary is present: {latest_bin}")

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print(f"Software version updated (from: {control.get_software_version()} to: {Version(version)})")
        package_updated = True
    else:
        print(f"Software version up-to-date ({Version(version)})")

    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated